-------------------------------------------------------------------------------------------------
-- Builds the actual UI --
-------------------------------------------------------------------------------------------------
Raidificator.BuildUI = function()

	-- top level window
	Raidificator._gui = Raidificator._wm:CreateTopLevelWindow("RaidificatorGUI");
	Raidificator._gui:SetDimensions(320, 30);
	Raidificator._gui:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, Raidificator.SavedVariables.offsetX, Raidificator.SavedVariables.offsetY);
	Raidificator._gui:SetClampedToScreen(true);
	Raidificator._gui:SetMouseEnabled(true);
	Raidificator._gui:SetMovable(Raidificator.SavedVariables.isMovable);
	Raidificator._gui:SetHidden(true);
	Raidificator._gui:SetAlpha(1);
	Raidificator._gui:SetHandler("OnMoveStop", Raidificator.SaveGUILocation);

	-- backdrop
	Raidificator._gui.backdrop = Raidificator._wm:CreateControl(nil, Raidificator._gui, CT_BACKDROP);
	Raidificator._gui.backdrop:SetAnchorFill(Raidificator._gui);
	Raidificator._gui.backdrop:SetCenterColor(0.0, 0.0, 0.0, 0.2);
	Raidificator._gui.backdrop:SetEdgeColor(0, 0, 0, 0.3);
	Raidificator._gui.backdrop:SetEdgeTexture(nil, 1, 1, 1.0, 1.0);

	-- elapsed time
	Raidificator._gui.elapsedTime = Raidificator._wm:CreateControl(nil, Raidificator._gui, CT_CONTROL);
	Raidificator._gui.elapsedTime:SetDimensions(110, 30);
	Raidificator._gui.elapsedTime:SetAnchor(TOPLEFT, Raidificator._gui, TOPLEFT, 0, 0);

	Raidificator._gui.elapsedTime.label = Raidificator._wm:CreateControl(nil, Raidificator._gui.elapsedTime, CT_LABEL);
	Raidificator._gui.elapsedTime.label:SetDimensions(76, 30);
	Raidificator._gui.elapsedTime.label:SetAnchor(LEFT, Raidificator._gui.elapsedTime, LEFT, 34, 0);
	Raidificator._gui.elapsedTime.label:SetHorizontalAlignment(0);
	Raidificator._gui.elapsedTime.label:SetVerticalAlignment(1);
	Raidificator._gui.elapsedTime.label:SetFont(Raidificator._font);

	Raidificator._gui.elapsedTime.icon = Raidificator._wm:CreateControl(nil, Raidificator._gui.elapsedTime, CT_TEXTURE);
	Raidificator._gui.elapsedTime.icon:SetDimensions(22, 20);
	Raidificator._gui.elapsedTime.icon:SetAnchor(LEFT, Raidificator._gui.elapsedTime, LEFT, 10, 0);
	Raidificator._gui.elapsedTime.icon:SetTexture("/esoui/art/miscellaneous/timer_32.dds");

	-- souls
	Raidificator._gui.souls = Raidificator._wm:CreateControl(nil, Raidificator._gui, CT_CONTROL);
	Raidificator._gui.souls:SetDimensions(90, 30);
	Raidificator._gui.souls:SetAnchor(LEFT, Raidificator._gui.elapsedTime, RIGHT, 0, 0);

	Raidificator._gui.souls.label = Raidificator._wm:CreateControl(nil, Raidificator._gui.souls, CT_LABEL);
	Raidificator._gui.souls.label:SetDimensions(76, 30);
	Raidificator._gui.souls.label:SetAnchor(LEFT, Raidificator._gui.souls, LEFT, 34, 0);
	Raidificator._gui.souls.label:SetHorizontalAlignment(0);
	Raidificator._gui.souls.label:SetVerticalAlignment(1);
	Raidificator._gui.souls.label:SetFont(Raidificator._font);

	Raidificator._gui.souls.icon = Raidificator._wm:CreateControl(nil, Raidificator._gui.souls, CT_TEXTURE);
	Raidificator._gui.souls.icon:SetDimensions(20, 20);
	Raidificator._gui.souls.icon:SetAnchor(LEFT, Raidificator._gui.souls, LEFT, 10, 0);
	Raidificator._gui.souls.icon:SetTexture("/esoui/art/trials/vitalitydepletion.dds");

	-- score
	Raidificator._gui.score = Raidificator._wm:CreateControl(nil, Raidificator._gui, CT_CONTROL);
	Raidificator._gui.score:SetDimensions(120, 30);
	Raidificator._gui.score:SetAnchor(LEFT, Raidificator._gui.souls, RIGHT, 0, 0);

	Raidificator._gui.score.label = Raidificator._wm:CreateControl(nil, Raidificator._gui.score, CT_LABEL);
	Raidificator._gui.score.label:SetDimensions(76, 30);
	Raidificator._gui.score.label:SetAnchor(LEFT, Raidificator._gui.score, LEFT, 34, 0);
	Raidificator._gui.score.label:SetHorizontalAlignment(0);
	Raidificator._gui.score.label:SetVerticalAlignment(1);
	Raidificator._gui.score.label:SetFont(Raidificator._font);

	Raidificator._gui.score.icon = Raidificator._wm:CreateControl(nil, Raidificator._gui.score, CT_TEXTURE);
	Raidificator._gui.score.icon:SetDimensions(20, 20);
	Raidificator._gui.score.icon:SetAnchor(LEFT, Raidificator._gui.score, LEFT, 10, 0);
	Raidificator._gui.score.icon:SetTexture("/esoui/art/buttons/pointsplus_up.dds");

	Raidificator.BuildHistoryUI();
end

Raidificator.BuildHistoryUI = function()

	-- history
	Raidificator._gui.history = Raidificator._wm:CreateTopLevelWindow("RaidificatorHistoryGUI");
	Raidificator._gui.history:SetDimensions(720, 500);
	Raidificator._gui.history:SetAnchor(CENTER, GuiRoot, CENTER, 0, -100);
	Raidificator._gui.history:SetAlpha(1);
	Raidificator._gui.history:SetHidden(true);

	-- backdrop
	Raidificator._gui.history.backdrop = Raidificator._wm:CreateControl(nil, Raidificator._gui.history, CT_BACKDROP);
	Raidificator._gui.history.backdrop:SetAnchorFill(Raidificator._gui.history);
	Raidificator._gui.history.backdrop:SetCenterColor(0.0, 0.0, 0.0, 0.6);
	Raidificator._gui.history.backdrop:SetEdgeColor(0, 0, 0, 0.8);
	Raidificator._gui.history.backdrop:SetEdgeTexture(nil, 1, 1, 1.0, 1.0);

	-- title container
	Raidificator._gui.history.title = Raidificator._wm:CreateControl(nil, Raidificator._gui.history, CT_CONTROL);
	Raidificator._gui.history.title:SetDimensions(720, 100);
	Raidificator._gui.history.title:SetAnchor(TOP, Raidificator._gui.history, TOP, 0, 0);

	-- title label
	Raidificator._gui.history.title.label = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.title, CT_LABEL);
	Raidificator._gui.history.title.label:SetDimensions(720, 60);
	Raidificator._gui.history.title.label:SetAnchor(CENTER, Raidificator._gui.history.title, CENTER, 0, 0);
	Raidificator._gui.history.title.label:SetHorizontalAlignment(1);
	Raidificator._gui.history.title.label:SetVerticalAlignment(1);
	Raidificator._gui.history.title.label:SetFont(Raidificator._fontLarge);
	Raidificator._gui.history.title.label:SetText("Raidificator History");

	-- title divider
	Raidificator._gui.history.title.divider = Raidificator._wm:CreateControlFromVirtual(nil, Raidificator._gui.history.title.label, "ZO_Options_Divider");
	Raidificator._gui.history.title.divider:SetWidth(600);
	Raidificator._gui.history.title.divider:SetAnchor(CENTER, Raidificator._gui.history.title.label, BOTTOM, 0, 0);

	-- scroll
	Raidificator._gui.history.scroll = Raidificator._wm:CreateControl(nil, Raidificator._gui.history, CT_CONTROL); -- CT_CONTROL
	Raidificator._gui.history.scroll:SetDimensions(720, 380);
	Raidificator._gui.history.scroll:SetAnchor(TOP, Raidificator._gui.history, TOP, 70, 110);
	Raidificator._gui.history.scroll.entries = {};
	Raidificator._gui.history.scroll:SetMouseEnabled(true)

	Raidificator._gui.history.scroll:SetHandler("OnMouseWheel", function(self, delta)

		local currentValue = Raidificator._gui.history.slider:GetValue();

		if delta > 0 then
			Raidificator._gui.history.slider:SetValue(currentValue - 1);
		else
			Raidificator._gui.history.slider:SetValue(currentValue + 1);
		end
	end)

	-- slider
	local texture = "/esoui/art/miscellaneous/scrollbox_elevator_disabled.dds";
	Raidificator._gui.history.slider = WINDOW_MANAGER:CreateControl(nil, Raidificator._gui.history.scroll, CT_SLIDER);
	Raidificator._gui.history.slider:SetDimensions(13, 330);
	Raidificator._gui.history.slider:SetMouseEnabled(true);
	Raidificator._gui.history.slider:SetThumbTexture(texture, texture, texture, 13, 35, 0, 0, 1, 1);
	Raidificator._gui.history.slider:SetValue(0);
	Raidificator._gui.history.slider:SetValueStep(1);
	Raidificator._gui.history.slider:SetAnchorFill();
	Raidificator._gui.history.slider:SetMinMax(Raidificator._history.minEntries, Raidificator._history.maxEntries);
	Raidificator._gui.history.slider:ClearAnchors();
	Raidificator._gui.history.slider:SetAnchor(TOPLEFT, Raidificator._gui.history.scroll, TOPLEFT, Raidificator._gui.history.scroll:GetWidth() - 100, 0);

	-- draw initial headers
	Raidificator.BuildHistoryTableHeader();

	for index = 1, Raidificator._history.maxEntries do
		local entryItem = Raidificator.BuildHistoryTableEntry(index);
		table.insert(Raidificator._gui.history.scroll.entries, index, entryItem);
	end

	-- draw default history
	Raidificator.DrawHistory(1, 1, Raidificator._history.sorters.byScore, Raidificator._history.sortingDirection.descending);

	Raidificator._gui.history.slider:SetHandler("OnValueChanged", function(self, value)

		local isHidden = self:IsHidden();

		if isHidden then
			-- scrolling not active
			return
		end

		Raidificator.DrawHistory(Raidificator._state.history.trialId, value, Raidificator._state.history.sorting, Raidificator._state.history.sortingDirection);
	end)

	-- build trial selectors
	Raidificator.BuildTrialSelectors();
end

Raidificator.TraverseSorterIcon = function(sorterIcon, sorterType)

	-- determine whether this sorter is active
	if  Raidificator._state.history.sorting == sorterType and
		Raidificator._state.history.sortingDirection == Raidificator._history.sortingDirection.descending then

		-- set ascending as texture
		sorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortup.dds");
	else

		-- default is descending
		sorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortdown.dds");
	end
end

Raidificator.ResetSorterIcon = function(sorterIcon, sorterType)

	-- determine whether this sorter is active
	if  Raidificator._state.history.sorting == sorterType and
		Raidificator._state.history.sortingDirection == Raidificator._history.sortingDirection.descending then

		-- this sorter is active and should be descending
		sorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortdown.dds");
	elseif 	Raidificator._state.history.sorting == sorterType and
			Raidificator._state.history.sortingDirection == Raidificator._history.sortingDirection.ascending then

		-- this sorter is active and should be ascending
		sorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_sortup.dds");
	else

		-- this sorter isn't active
		sorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");
	end
end

Raidificator.ResetSorterIcons = function()

	Raidificator.ResetSorterIcon(Raidificator._gui.history.scoreSorterIcon, Raidificator._history.sorters.byScore);
	Raidificator.ResetSorterIcon(Raidificator._gui.history.timeElapsedSorterIcon, Raidificator._history.sorters.byTotalTime);
	Raidificator.ResetSorterIcon(Raidificator._gui.history.soulsSorterIcon, Raidificator._history.sorters.bySouls);
	Raidificator.ResetSorterIcon(Raidificator._gui.history.completionDateSorterIcon, Raidificator._history.sorters.byDate);
	Raidificator.ResetSorterIcon(Raidificator._gui.history.characterSorterIcon, Raidificator._history.sorters.byCharacter);
end

Raidificator.OnSortClick = function(sorterType)

	local sortingDirection = nil;

	if Raidificator._state.history.sorting ~= sorterType then

		-- not active, use default
		sortingDirection = Raidificator._history.sortingDirection.descending;
	elseif Raidificator._state.history.sortingDirection == Raidificator._history.sortingDirection.ascending then

		-- active and ascending, switch to descending
		sortingDirection = Raidificator._history.sortingDirection.descending;
	elseif Raidificator._state.history.sortingDirection == Raidificator._history.sortingDirection.descending then

		-- active and descending, switch to ascending
		sortingDirection = Raidificator._history.sortingDirection.ascending;
	end

	-- get current slider value as start index
	local startIndex = Raidificator._gui.history.slider:GetValue();

	-- render history
	Raidificator.DrawHistory(Raidificator._state.history.trialId, startIndex, sorterType, sortingDirection);
end

Raidificator.BuildHistoryTableHeader = function()

	-- container
	local container = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.scroll, CT_CONTROL);
	container:SetDimensions(720, 30);
	container:SetAnchor(TOPLEFT, Raidificator._gui.history.scroll, TOPLEFT, 0, 0);

	-- score
	local score = Raidificator._wm:CreateControl(nil, container, CT_BUTTON);
	score:SetDimensions(100, 30);
	score:SetAnchor(TOPLEFT, container, TOPLEFT, -32, 0);
	score:SetFont(Raidificator._fontSmall);
	score:SetText('Score');
	score:SetMouseEnabled(true);
	score:SetHandler("OnClicked",function(self)
		Raidificator.OnSortClick(Raidificator._history.sorters.byScore);
	end);

	Raidificator._gui.history.scoreSorterIcon = Raidificator._wm:CreateControl(nil, score, CT_TEXTURE);
	Raidificator._gui.history.scoreSorterIcon:SetDimensions(16, 32);
	Raidificator._gui.history.scoreSorterIcon:SetAnchor(LEFT, score, LEFT, 10, -5);
	Raidificator._gui.history.scoreSorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");

	score:SetHandler("OnMouseEnter",function(self)
		Raidificator.TraverseSorterIcon(Raidificator._gui.history.scoreSorterIcon, Raidificator._history.sorters.byScore);
	end);

	score:SetHandler("OnMouseExit",function(self)
		Raidificator.ResetSorterIcon(Raidificator._gui.history.scoreSorterIcon, Raidificator._history.sorters.byScore);
	end);

	-- time elapsed
	local timeElapsed = Raidificator._wm:CreateControl(nil, container, CT_BUTTON);
	timeElapsed:SetDimensions(100, 30);
	timeElapsed:SetAnchor(TOPLEFT, container, TOPLEFT, 66, 0);
	timeElapsed:SetFont(Raidificator._fontSmall);
	timeElapsed:SetText('Time');
	timeElapsed:SetMouseEnabled(true);
	timeElapsed:SetHandler("OnClicked",function(self)
		Raidificator.OnSortClick(Raidificator._history.sorters.byTotalTime);
	end);

	Raidificator._gui.history.timeElapsedSorterIcon = Raidificator._wm:CreateControl(nil, timeElapsed, CT_TEXTURE);
	Raidificator._gui.history.timeElapsedSorterIcon:SetDimensions(16, 32);
	Raidificator._gui.history.timeElapsedSorterIcon:SetAnchor(LEFT, timeElapsed, LEFT, 10, -5);
	Raidificator._gui.history.timeElapsedSorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");

	timeElapsed:SetHandler("OnMouseEnter",function(self)
		Raidificator.TraverseSorterIcon(Raidificator._gui.history.timeElapsedSorterIcon, Raidificator._history.sorters.byTotalTime);
	end);

	timeElapsed:SetHandler("OnMouseExit",function(self)
		Raidificator.ResetSorterIcon(Raidificator._gui.history.timeElapsedSorterIcon, Raidificator._history.sorters.byTotalTime);
	end);

	-- souls
	local souls = Raidificator._wm:CreateControl(nil, container, CT_BUTTON);
	souls:SetDimensions(100, 30);
	souls:SetAnchor(TOPLEFT, container, TOPLEFT, 167, 0);
	souls:SetFont(Raidificator._fontSmall);
	souls:SetText('Vitality');
	souls:SetMouseEnabled(true);
	souls:SetHandler("OnClicked",function(self)
		Raidificator.OnSortClick(Raidificator._history.sorters.bySouls);
	end);

	Raidificator._gui.history.soulsSorterIcon = Raidificator._wm:CreateControl(nil, souls, CT_TEXTURE);
	Raidificator._gui.history.soulsSorterIcon:SetDimensions(16, 32);
	Raidificator._gui.history.soulsSorterIcon:SetAnchor(LEFT, souls, LEFT, 10, -5);
	Raidificator._gui.history.soulsSorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");

	souls:SetHandler("OnMouseEnter",function(self)
		Raidificator.TraverseSorterIcon(Raidificator._gui.history.soulsSorterIcon, Raidificator._history.sorters.bySouls);
	end);

	souls:SetHandler("OnMouseExit",function(self)
		Raidificator.ResetSorterIcon(Raidificator._gui.history.soulsSorterIcon, Raidificator._history.sorters.bySouls);
	end);

	-- date
	local completionDate = Raidificator._wm:CreateControl(nil, container, CT_BUTTON);
	completionDate:SetDimensions(100, 30);
	completionDate:SetAnchor(TOPLEFT, container, TOPLEFT, 267, 0);
	completionDate:SetFont(Raidificator._fontSmall);
	completionDate:SetText('Date');
	completionDate:SetMouseEnabled(true);
	completionDate:SetHandler("OnClicked",function(self)
		Raidificator.OnSortClick(Raidificator._history.sorters.byDate);
	end);

	Raidificator._gui.history.completionDateSorterIcon = Raidificator._wm:CreateControl(nil, completionDate, CT_TEXTURE);
	Raidificator._gui.history.completionDateSorterIcon:SetDimensions(16, 32);
	Raidificator._gui.history.completionDateSorterIcon:SetAnchor(LEFT, completionDate, LEFT, 10, -5);
	Raidificator._gui.history.completionDateSorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");

	completionDate:SetHandler("OnMouseEnter",function(self)
		Raidificator.TraverseSorterIcon(Raidificator._gui.history.completionDateSorterIcon, Raidificator._history.sorters.byDate);
	end);

	completionDate:SetHandler("OnMouseExit",function(self)
		Raidificator.ResetSorterIcon(Raidificator._gui.history.completionDateSorterIcon, Raidificator._history.sorters.byDate);
	end);

	-- character(s) 486
	local character = Raidificator._wm:CreateControl(nil, container, CT_BUTTON);
	character:SetDimensions(100, 30);
	character:SetAnchor(TOPLEFT, container, TOPLEFT, 386, 0);
	character:SetFont(Raidificator._fontSmall);
	character:SetText('Character');
	character:SetMouseEnabled(true);
	character:SetHandler("OnClicked",function(self)
		Raidificator.OnSortClick(Raidificator._history.sorters.byCharacter);
	end);

	Raidificator._gui.history.characterSorterIcon = Raidificator._wm:CreateControl(nil, character, CT_TEXTURE);
	Raidificator._gui.history.characterSorterIcon:SetDimensions(16, 32);
	Raidificator._gui.history.characterSorterIcon:SetAnchor(LEFT, character, LEFT, -8, -5);
	Raidificator._gui.history.characterSorterIcon:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds");

	character:SetHandler("OnMouseEnter",function(self)
		Raidificator.TraverseSorterIcon(Raidificator._gui.history.characterSorterIcon, Raidificator._history.sorters.byCharacter);
	end);

	character:SetHandler("OnMouseExit",function(self)
		Raidificator.ResetSorterIcon(Raidificator._gui.history.characterSorterIcon, Raidificator._history.sorters.byCharacter);
	end);

	-- info
	local info = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	info:SetDimensions(100, 30);
	info:SetAnchor(TOPLEFT, container, TOPLEFT, 510, 0);
	info:SetFont(Raidificator._fontSmall);
	info:SetText('Info');
end

Raidificator.BuildHistoryTableEntry = function(index)

	local marginTop = index * 30;

	-- container
	local container = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.scroll, CT_CONTROL);
	container:SetDimensions(720, 30);
	container:SetAnchor(TOPLEFT, Raidificator._gui.history.scroll, TOPLEFT, 0, marginTop);

	-- score
	local score = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	score:SetDimensions(100, 30);
	score:SetAnchor(TOPLEFT, container, TOPLEFT, 0, 0);
	score:SetFont(Raidificator._fontXSmall);

	-- time elapsed
	local timeElapsed = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	timeElapsed:SetDimensions(100, 30);
	timeElapsed:SetAnchor(TOPLEFT, container, TOPLEFT, 100, 0);
	timeElapsed:SetFont(Raidificator._fontXSmall);

	-- souls
	local souls = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	souls:SetDimensions(100, 30);
	souls:SetAnchor(TOPLEFT, container, TOPLEFT, 200, 0);
	souls:SetFont(Raidificator._fontXSmall);

	-- date
	local completionDate = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	completionDate:SetDimensions(100, 30);
	completionDate:SetAnchor(TOPLEFT, container, TOPLEFT, 300, 0);
	completionDate:SetFont(Raidificator._fontXSmall);

	-- character(s)
	local character = Raidificator._wm:CreateControl(nil, container, CT_LABEL);
	character:SetDimensions(100, 30);
	character:SetAnchor(TOPLEFT, container, TOPLEFT, 400, 0);
	character:SetFont(Raidificator._fontXSmall);

	-- info
	local info = Raidificator._wm:CreateControl(nil, container, CT_CONTROL);
	info:SetDimensions(100, 30);
	info:SetAnchor(TOPLEFT, container, TOPLEFT, 500, 0);
	info:SetHidden(true);

	-- group info
	info.groupMembers = Raidificator._wm:CreateControl(nil, info, CT_BUTTON);
	info.groupMembers:SetDimensions(100, 30);
	info.groupMembers:SetAnchor(TOPLEFT, info, TOPLEFT, 0, -5);
	info.groupMembers:SetMouseEnabled(true);

	-- group info icon
	info.groupMembersIcon = Raidificator._wm:CreateControl(nil, info.groupMembers, CT_TEXTURE);
	info.groupMembersIcon:SetDimensions(32, 32);
	info.groupMembersIcon:SetAnchor(LEFT, info.groupMembers, LEFT, 0, 0);
	info.groupMembersIcon:SetTexture("/esoui/art/campaign/campaignbrowser_group.dds");

	local entryItem = {
		container = container,
		score = score,
		timeElapsed = timeElapsed,
		souls = souls,
		completionDate = completionDate,
		character = character,
		info = info
	};

	return entryItem;
end

Raidificator.ShallowCopy = function(tableToCopy)

	local copy = {};

	for key, value in pairs(tableToCopy) do
		copy[key] = value;
	end

	return copy;
end

Raidificator.SortByScore = function(tableToSort, sortDirection)

	table.sort(tableToSort, function(a, b)
		if sortDirection == Raidificator._history.sortingDirection.ascending then

			return a.score < b.score;
		else

			return b.score < a.score;
		end
	end);
end

Raidificator.SortByDate = function(tableToSort, sortDirection)

	table.sort(tableToSort, function(a, b)
		if sortDirection == Raidificator._history.sortingDirection.ascending then

			return a.completed < b.completed;
		else

			return b.completed < a.completed;
		end
	end);
end

Raidificator.SortByTotalTime = function(tableToSort, sortDirection)

	table.sort(tableToSort, function(a, b)
		if sortDirection == Raidificator._history.sortingDirection.ascending then

			return a.timeInSeconds < b.timeInSeconds;
		else

			return b.timeInSeconds < a.timeInSeconds;
		end
	end);
end

Raidificator.SortByCharacter = function(tableToSort, sortDirection)

	table.sort(tableToSort, function(a, b)
		if sortDirection == Raidificator._history.sortingDirection.ascending then

			return a.character < b.character;
		else

			return b.character < a.character;
		end
	end);
end

Raidificator.SortBySouls = function(tableToSort, sortDirection)

	table.sort(tableToSort, function(a, b)
		if sortDirection == Raidificator._history.sortingDirection.ascending then

			return a.revives < b.revives;
		else

			return b.revives < a.revives;
		end
	end);
end

Raidificator.Sort = function(sorting, sortingDirection)

	if  Raidificator._state.history.sorting == sorting and
		Raidificator._state.history.sortingDirection == sortingDirection then
		-- already active sorting
		return
	end

	-- set as active sorting
	Raidificator._state.history.sorting = sorting;

	-- set direction as active
	Raidificator._state.history.sortingDirection = sortingDirection;

	-- reset sorter icons
	Raidificator.ResetSorterIcons();

	local trialHistory = Raidificator._state.history.trials;

	-- perform actual sorting
	if sorting == Raidificator._history.sorters.byScore then

		Raidificator.SortByScore(trialHistory, sortingDirection);

	elseif sorting == Raidificator._history.sorters.byDate then

		Raidificator.SortByDate(trialHistory, sortingDirection);

	elseif sorting == Raidificator._history.sorters.byTotalTime then

		Raidificator.SortByTotalTime(trialHistory, sortingDirection);

	elseif sorting == Raidificator._history.sorters.byCharacter then

		Raidificator.SortByCharacter(trialHistory, sortingDirection);

	elseif sorting == Raidificator._history.sorters.bySouls then

		Raidificator.SortBySouls(trialHistory, sortingDirection);

	end
end

Raidificator.SetTrial = function(raidId)

	if Raidificator._state.history.trialId == raidId then
		-- already set as this trial
		return
	end

	-- set trial as active
	Raidificator._state.history.trialId = raidId;

	-- no sorting active by default
	Raidificator._state.history.sorting = nil;

	local trialHistory = Raidificator.SavedVariables.history[raidId];

	if trialHistory == nil then
		-- no history
		Raidificator._gui.history.slider:SetHidden(true);
		Raidificator._state.history.trials = {};
		return
	end

	-- copy the table
	local copy = Raidificator.ShallowCopy(trialHistory);

	local numberOfTrials = table.getn(copy);

	local maxSlider = nil;

	if numberOfTrials > Raidificator._history.maxEntries then

		-- ensure we display slider
		Raidificator._gui.history.slider:SetHidden(false);

		-- adjust max slider value
		maxSlider = numberOfTrials - 9;
	else
		-- no need to display slider
		Raidificator._gui.history.slider:SetHidden(true);

		-- doesnt matter what we set this to since it's not visible
		maxSlider = numberOfTrials;
	end

	-- ensure we adjust the slider each time history changes
	Raidificator._gui.history.slider:SetMinMax(Raidificator._history.minEntries, maxSlider);

	-- set the state trials
	Raidificator._state.history.trials = copy;
end

Raidificator.DrawHistory = function(raidId, startIndex, sorting, sortingDirection)

	Raidificator.SetTrial(raidId);

	if Raidificator._state.history.sorting ~= sorting or
	   Raidificator._state.history.sortingDirection ~= sortingDirection then
		-- ensure we change sorting
		Raidificator.Sort(sorting, sortingDirection);
	end

	local trialHistory = Raidificator._state.history.trials;

	local trialIndex = startIndex;

	for index = Raidificator._history.minEntries, Raidificator._history.maxEntries do

		local trial = trialHistory[trialIndex];

		if trial == nil then

			-- empty trial
			Raidificator._gui.history.scroll.entries[index].score:SetText('');
			Raidificator._gui.history.scroll.entries[index].timeElapsed:SetText('');
			Raidificator._gui.history.scroll.entries[index].souls:SetText('');
			Raidificator._gui.history.scroll.entries[index].completionDate:SetText('');
			Raidificator._gui.history.scroll.entries[index].character:SetText('');
			Raidificator._gui.history.scroll.entries[index].info:SetHidden(true);
		else

			-- calculate hours, minutes and seconds
			local elapsedHours = math.floor(trial.timeInSeconds / 3600);
			local elapsedMinutes = math.floor((trial.timeInSeconds / 60) % 60);
			local elapsedSeconds = trial.timeInSeconds % 60;

			local raidTime = string.format(
				"%.2d:%.2d:%.2d",
				elapsedHours,
				elapsedMinutes,
				elapsedSeconds
			);

			-- populate entry
			Raidificator._gui.history.scroll.entries[index].score:SetText(trial.score);
			Raidificator._gui.history.scroll.entries[index].timeElapsed:SetText(raidTime);
			Raidificator._gui.history.scroll.entries[index].souls:SetText(trial.revives .. '/' .. (trial.revives + trial.deaths));
			Raidificator._gui.history.scroll.entries[index].completionDate:SetText(GetDateStringFromTimestamp(trial.completed));
			Raidificator._gui.history.scroll.entries[index].character:SetText(trial.character);

			-- determine if we have any info
			if trial.groupMembers ~= nil then

				-- ensure visibility of the info container
				Raidificator._gui.history.scroll.entries[index].info:SetHidden(false);

				Raidificator._gui.history.scroll.entries[index].info.groupMembers:SetHandler("OnClicked", function(self)

					Raidificator.Log("Group members:");
					Raidificator.Log(trial.character);

					for key, value in pairs(trial.groupMembers) do

						Raidificator.Log(value);
					end
				end);
			else
				-- no info, hide container
				Raidificator._gui.history.scroll.entries[index].info:SetHidden(true);
			end
		end

		trialIndex = trialIndex + 1;
	end
end

Raidificator.BuildTrialSelectors = function()

	Raidificator._gui.history.trialChanger = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.scroll, CT_CONTROL);
	Raidificator._gui.history.trialChanger:SetDimensions(720, 100);
	Raidificator._gui.history.trialChanger:SetAnchor(BOTTOMLEFT, Raidificator._gui.history.scroll, BOTTOMLEFT, 0, 65);

	local activeTrial = Raidificator._trials[Raidificator._state.history.trialId];

	Raidificator._gui.history.trialName = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.trialChanger, CT_LABEL);
	Raidificator._gui.history.trialName:SetDimensions(200, 30);
	Raidificator._gui.history.trialName:SetAnchor(TOPLEFT, Raidificator._gui.history.trialChanger, TOPLEFT, 190, 0);
	Raidificator._gui.history.trialName:SetFont(Raidificator._font);
	Raidificator._gui.history.trialName:SetHorizontalAlignment(1);
	Raidificator._gui.history.trialName:SetText(activeTrial.name);

	Raidificator._gui.history.trialChangerPrevious = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.trialName, CT_BUTTON);
	Raidificator._gui.history.trialChangerPrevious:SetAnchor(CENTER, Raidificator._gui.history.trialName, CENTER, -110, 0);
	Raidificator._gui.history.trialChangerPrevious:SetDimensions(32, 32);
	Raidificator._gui.history.trialChangerPrevious:SetMouseEnabled(true);
	Raidificator._gui.history.trialChangerPrevious:SetHandler("OnClicked", function(self)

		local trialIndex = Raidificator.GetIndexOfTrial(Raidificator._state.history.trialId);

		if trialIndex == nil then
			return
		end

		local previousTrial = Raidificator._trials[trialIndex - 1];

		if previousTrial == nil then
			return
		end

		Raidificator._gui.history.trialName:SetText(previousTrial.name);

		local startIndex = 1;

		Raidificator._gui.history.slider:SetValue(startIndex);

		Raidificator.DrawHistory(previousTrial.id, startIndex, Raidificator._state.history.sorting, Raidificator._state.history.sortingDirection);
	end)

	Raidificator._gui.history.trialChangerPreviousIcon = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.trialChangerPrevious, CT_TEXTURE);
	Raidificator._gui.history.trialChangerPreviousIcon:SetDimensions(32, 32);
	Raidificator._gui.history.trialChangerPreviousIcon:SetAnchor(LEFT, Raidificator._gui.history.trialChangerPrevious, LEFT, 0, 0);
	Raidificator._gui.history.trialChangerPreviousIcon:SetTexture("Raidificator/media/left.dds");

	Raidificator._gui.history.trialChangerPrevious:SetHandler("OnMouseEnter",function(self)
		Raidificator._gui.history.trialChangerPreviousIcon:SetTexture("Raidificator/media/left_3.dds");
	end);

	Raidificator._gui.history.trialChangerPrevious:SetHandler("OnMouseExit",function(self)
		Raidificator._gui.history.trialChangerPreviousIcon:SetTexture("Raidificator/media/left.dds");
	end);

	Raidificator._gui.history.trialChangerNext = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.trialName, CT_BUTTON);
	Raidificator._gui.history.trialChangerNext:SetAnchor(CENTER, Raidificator._gui.history.trialName, CENTER, 110, 0);
	Raidificator._gui.history.trialChangerNext:SetDimensions(32, 32);
	Raidificator._gui.history.trialChangerNext:SetMouseEnabled(true);
	Raidificator._gui.history.trialChangerNext:SetHandler("OnClicked", function(self)

		local trialIndex = Raidificator.GetIndexOfTrial(Raidificator._state.history.trialId);

		if trialIndex == nil then
			return
		end

		local nextTrial = Raidificator._trials[trialIndex + 1];

		if nextTrial == nil then
			return
		end

		Raidificator._gui.history.trialName:SetText(nextTrial.name);

		local startIndex = 1;

		Raidificator._gui.history.slider:SetValue(startIndex);

		Raidificator.DrawHistory(nextTrial.id, startIndex, Raidificator._state.history.sorting, Raidificator._state.history.sortingDirection);
	end)

	Raidificator._gui.history.trialChangerNextIcon = Raidificator._wm:CreateControl(nil, Raidificator._gui.history.trialChangerNext, CT_TEXTURE);
	Raidificator._gui.history.trialChangerNextIcon:SetDimensions(32, 32);
	Raidificator._gui.history.trialChangerNextIcon:SetAnchor(LEFT, Raidificator._gui.history.trialChangerNext, LEFT, 0, 0);
	Raidificator._gui.history.trialChangerNextIcon:SetTexture("Raidificator/media/right.dds");

	Raidificator._gui.history.trialChangerNext:SetHandler("OnMouseEnter",function(self)
		Raidificator._gui.history.trialChangerNextIcon:SetTexture("Raidificator/media/right_3.dds");
	end);

	Raidificator._gui.history.trialChangerNext:SetHandler("OnMouseExit",function(self)
		Raidificator._gui.history.trialChangerNextIcon:SetTexture("Raidificator/media/right.dds");
	end);
end

Raidificator.GetIndexOfTrial = function(trialId)

	for _, trial in ipairs(Raidificator._trials) do

		if trial.id == trialId then
			return _;
		end
	end

	return nil;
end
